		page	58,132

; dosf2.asm
; contains: dosfsize(),dosgetmod(),doschmod(),dosversion(),diskfree(),
; contains: gfsize()
;
		include	model.h
		include	prologue.h
		include equ.h
		name	dosf2
		dseg	dosf2

;  variables for 32x32 multiply
;
hi_mcnd		dw	?
lo_mcnd		dw	?
hi_pp1		dw	?
lo_pp1		dw	?
hi_pp2		dw	?
lo_pp2		dw	?
hi_pp3		dw	?
lo_pp3		dw	?
hi_pp4		dw	?
lo_pp4		dw	?
		endds

		pseg	dosf2

;==>--	long gfsize(filename)
;
;;	ARGUMENTS:
;	  (char *)		filename -  Null terminated string containing
;					    drive:\path\filename.ext
;
;;	DESCRIPTION:
;	  Opens file, seeks to end and closes file, returns the length
;	  of the file in bytes or a (long) negative dos error code.
;
;;	RETURNS:
;	  0 or greater file size in bytes, or negative (long) dos error code
;
;;	AUTHOR:
;	  ""   16-APR-1987  13:31:27.83
;	   Copyright (C)1987-1990 Greenleaf Software Inc. All Rights Reserved.
;;;
	cproc	gfsize
	if	_LDATA
	 push	ds
	 lds	dx,parm1_
	else
	 mov	dx,parm1_
	endif
	mov	ax,3d00h	;open file for reading
	int	21h
	jnc	fsopok
	ifdef	AXBX32
	 mov	bx,ax
	 mov	ax,8000h	;ax:bx = -error code
	else
	 mov	dx,8000h	;dx:ax = -error code
	endif
	jmp	short fsexit
fsopok:	mov	bx,ax		;bx=file handle
	mov	ax,4202h	;move to end plus offset
	xor	cx,cx		;offset == 0:0
	mov	dx,cx
	int	21h		;dos LSEEK function
	pushf
	push	ax
	push	dx
	mov	ah,3eh		;close file
	int	21h
	pop	dx
	pop	ax
	popf
	jnc	fsekok
	ifdef	AXBX32
	 mov	bx,ax
	 mov	ax,-1		;ax:bx = error code
	else
	 mov	dx,-1		;dx:ax = error code
	endif
	jmp	short fsexit
fsekok:
	ifdef	AXBX32
	 mov	bx,ax
	 mov	ax,dx
	endif
fsexit:
	if	_LDATA
	 pop	ds
	endif
	cproce


;==>--	long dosfsize(table)
;
;;	ARGUMENTS:
;	  (struct DISKTABLE *)	table	table structure with filename
;
;;	DESCRIPTION:
;	  The FCB contained in the table structure is initialized with
;	  the drive and filename and extension.  dosparse() may be used
;	  to accomplish the above.  The lrs (logical record size) field
;	  is then set to the number of bytes per record for the file.  This
;	  function then fills in the fcbrec random record field with the
;	  number of records in the file, rounded up to the nearest whole
;	  record.
;
;;	RETURNS:
;	  If lrs = 1, returns number of bytes in the file, or (long)0 if
;		      file not found.
;	  If lrs > 1, returns number of blocks in file of size lrs or
;		      (long) 0 if file not found.
;
;;	AUTHOR:
;	  Copyright (C)1987-1990 Greenleaf Software Inc. All Rights Reserved.
;
;;	MODIFICATIONS:
;
;;;
	cproc	dosfsize
	if	_LDATA
	 push	ds
	 lds	si,parm1_	;ds:si points to DISKTABLE
	else
	 mov	si,parm1_	;ds:si points to DISKTABLE
	endif
	mov	[si+fcb],0ffh	;set extended flag in fcb
	mov	dx,si
	add	dx,fcb		;ds:dx points to FCB
	mov	ah,23h		;dos function #23
	int	21h
	inc	al
	jz	_fsize1		;if file not found
	ifdef	AXBX32
	 mov	bx,[si+fcbrec]	;bx=low order word
	 mov	ax,[si+fcbrec+2];ax=high order word
	 xor	ah,ah		;clear high order byte
	else
	 mov	ax,[si+fcbrec]	;ax=low order word
	 mov	dx,[si+fcbrec+2];dx=high order word
	 xor	dh,dh
	endif
	jmp	short _fsize2
_fsize1:
	xor	ax,ax		;set long return value to 0
	ifdef	AXBX32
	 mov	bx,ax
	else
	 mov	dx,ax
	endif
_fsize2:
	if	_LDATA
	 pop	ds
	endif
	cproce

;==>--	int dosgetmod(table)
;
;;	ARGUMENTS:
;	  (struct DISKTABLE *)	table	points to disktable
;			table->string	= pointer to string containing drive,
;					  path, and filename.
;
;;	DESCRIPTION:
;	  Get file mode (attributes)
;
;;	RETURNS:
;	 1 if successful, 0 if unsuccessful, if 0 then error code is
;	 in tbl->status
;
;;	AUTHOR:
;	  Copyright (C)1987-1990 Greenleaf Software Inc. All Rights Reserved.
;;;
	cproc	dosgetmod,,dosgetmo
	if	_LDATA
	 push	ds
	 lds	bx,parm1_		;ds:bx points to DISKTABLE
	 lds	dx,[bx+string]		;ds:dx points to filename
	else
	 mov	bx,parm1_		;ds:bx points to DISKTABLE
	 mov	dx,[bx+string]		;ds:dx points to filename
	endif
	mov	ax,4300h		;get attribute function code
	int	21h
	if	_LDATA
	 lds	bx,parm1_		;re-establish ds:bx
	endif
	jc	gemerr
	mov	[bx+fattr],cl		;save attribute in structure
	mov	[bx+status],0		;clear error indicator
	mov	ax,1			;1 indicates success?
	jmp	short gemex		;and exit function
gemerr:	mov	[bx+status],ax		;save error code
	xor	ax,ax			;0 indicates error?
gemex:
	if	_LDATA
	 pop	ds
	endif
	cproce

;==>--	int doschmod(table)
;
;;	ARGUMENTS:
;	  (struct DISKTABLE *)	table	points to disktable
;			table->string	= pointer to string containing drive,
;					  path, and filename.
;
;;	DESCRIPTION:
;	  Change file mode (attributes)
;
;;	SIDE EFFECTS:
; 	  files attributes may change
;
;;	RETURNS:
;	 1 if successful, 0 if unsuccessful, if 0 then error code is
;	 in tbl->status
;
;;	AUTHOR:
;	  Copyright (C)1987-1990 Greenleaf Software Inc. All Rights Reserved.
;;;
	cproc	doschmod
	if	_LDATA
	 push	ds
	 lds	bx,parm1_		;ds:bx points to DISKTABLE
	 mov	cl,[bx+fattr]		;cx = attribute
	 xor	ch,ch
	 lds	dx,[bx+string]		;ds:dx points to filename
	else
	 mov	bx,parm1_		;ds:bx points to DISKTABLE
	 mov	cl,[bx+fattr]
	 xor	ch,ch			;cx = attribute
	 mov	dx,[bx+string]		;ds:dx points to filename
	endif
	mov	ax,4301h		;set attribute function code
	int	21h
	if	_LDATA
	 lds	bx,parm1_		;re-establish ds:bx
	endif
	jc	chmerr
	mov	[bx+status],0		;clear error indicator
	mov	ax,1			;1 indicates success?
	jmp	short chmex		;and exit function
chmerr:	mov	[bx+status],ax		;save error code
	xor	ax,ax			;0 indicates error?
chmex:
	if	_LDATA
	 pop	ds
	endif
	cproce

;==>--	unsigned dosversion(void)
;
;;	DESCRIPTION:
;	  Determine dos version
;
;;	RETURNS:
;	  Major revision level is in low order 8 bits, minor revision
;	  is in the high order 8 bits.  If version is pre version 2.0
;	  return a 0 in both bytes.
;
;;	AUTHOR:
;	  Copyright (C)1987-1990 Greenleaf Software Inc. All Rights Reserved.
;;;
	cproc	dosversion,,dosversi
	mov	ax,3000h
	int	21h
	cmp	al,0
	jne	dosve		;post-version 2
	xor	ax,ax		;if pre-version 2
dosve:
	cproce

;==>--	long diskfree(drive,option)
;
;;	ARGUMENTS:
;	  (int)		drive		-	drive: 0=DEFAULT, 1=A: etc
;	  (int)		option		-	One of the following:
;						0 = Free bytes on Drive
;						1 = Total bytes on drive
;						2 = Free Sectors
;						3 = Total Sectors
;						4 = Free Clustors
;						5 = Total Clustors
;						6 = Sectors Per Clustor
;						7 = Bytes Per Sector
;						8 = Bytes Per Clustor
;
;;	DESCRIPTION:
;	  The requested information is determined from dos.
;
;;	RETURNS:
;	  Requested information or (long)-1 if invalid drive specified
;
;;	AUTHOR:
;	  Copyright (C)1987-1990 Greenleaf Software Inc. All Rights Reserved.
;;;
	cproc	diskfree
	push	ds
	mov	dl,parm1_	;get drive to DL
	mov	ax,3600h	;function
	int	21h
	cmp	ax,0FFFFh	;if invalid drive
	je	dskfa		;BX=Free Clusters, AX=Sectors/Cluster, 
				;CX=Bytes/Sector and DX=Total Clusters 
				;on Drive
	mov	di,parm2_	;get Option:
	cmp	di,0
	jne	dskf1		;Opt=0:  Total Free Bytes = BX * AX * CX
	mul	cx		;DX:AX = AX * CX
	xor	cx,cx		;CX:BX = BX
	call	mult32		;DX:AX = result
	jmp	short	dskfr
dskf1:	cmp	di,1		;Opt=1:  Total Bytes in Drive = DX * AX * CX
	jne	dskf2
	push	dx
	mul	cx		;DX:AX = AX * CX
	pop	bx		;BX = DX
	xor	cx,cx		;CX:BX = DX
	call	mult32		;DX:AX = result
	jmp	short dskfr
dskf2:	cmp	di,2		;Opt=2:  Free Sectors = BX * AX
	jne	dskf3
	mul	bx		;DX:AX = BX * AX
	jmp	short dskfr
dskf3:	cmp	di,3		;Opt=3:  Total Sectors = DX * AX
	jne	dskf4
	mul	dx		;AX:DX = DX * AX
	jmp	short dskfr
dskf4:	cmp	di,4		;Opt=4: Free Clusters = BX
	jne	dskf5
	mov	ax,bx		;lo-order
	xor	dx,dx		;hi-order = 0
	jmp	short dskfr
dskf5:	cmp	di,5		;Opt=5:  Total Clusters = DX
	jne	dskf6
	mov	ax,dx		;lo=order
	xor	dx,dx		;hi=order = 0
	jmp	short dskfr
dskf6:	cmp	di,6		;Opt=6: Sectors per Cluster = AX
	jne	dskf7
	xor	dx,dx		;lo-order is in AX, hi-order = 0
	jmp	short dskfr
dskf7:	cmp	di,7		;Opt=7: Bytes per Sector = CX
	jne	dskf8
	mov	ax,cx		;lo-order
	xor	dx,dx		;hi-order = 0
	jmp	short dskfr

dskf8:	cmp	di,8		;Opt=8: Bytes/Cluster = AX * CX
	jne	dskfa		;if not this, is error arg
	mul	cx		;DX:AX = AX * CX
;
;  Normal Return:  Value is in DX:AX which is correct for CI C86
;  but other compilers use different conventions.  Lattice = AX:BX
;
dskfr:
	ifdef	AXBX32
	 mov	bx,ax		;lo-order part
	 mov	ax,dx		;hi-order part
	endif
dskfz:	pop	ds
	jmp	short dskfreexit
dskfa:	mov	ax,-1
	mov	dx,-1		;long -1
	mov	bx,-1
	jmp	short dskfz
dskfreexit:
	cproce

;***
;  32 * 32 multiply: On Entry, CX:BX=Multiplier, DX:AX=multiplicand
;
;  Exit:  DX:CX:BX:AX = RESULT
;
;  This is directly from Leo Scanlon's book "IBM PC Assembly Language".
;
mult32	proc near
	mov	hi_mcnd,dx	;save multiplicand
	mov	lo_mcnd,ax
	mul	bx		;form pp1
	mov	hi_pp1,dx
	mov	lo_pp1,ax
	mov	ax,hi_mcnd	;form pp2
	mul	bx
	mov	hi_pp2,dx
	mov	lo_pp2,ax
	mov	ax,lo_mcnd	;form pp3
	mul	cx
	mov	hi_pp3,dx
	mov	lo_pp3,ax
	mov	ax,hi_mcnd	;form pp4
	mul	cx
	mov	hi_pp4,dx
	mov	lo_pp4,ax
;  Add the partial products to form 64-bit final product
	mov	ax,lo_pp1	;lo 16-bits
	mov	bx,hi_pp1	;form mid-lower 16-bits
	add	bx,lo_pp2	;with sum #1
	adc	bx,lo_pp3	;and sum #2
	mov	cx,hi_pp2	;form mid-upper 16-bits
	adc	cx,hi_pp3
	adc	cx,lo_pp4
	mov	dx,hi_pp4	;form hi 16-bits
	adc	dx,0		;including any propagated carry
	mov	dx,bx		;format lo-order 32 bits in DX:AX and
	and	dx,7FFFh	;clear sign bit
	ret
mult32	endp
	endps
	end
