		page	58,132

;/*
;** dosxerr.asm
;** contains: dosexter()
;*/
		ifndef	_LCODE
		 include model.h
		endif
		include prologue.h
		name	dosexterr

GETEXTERROR	equ	059h			;DOS: Get extended error func #
DOSCALL 	equ	021h			;DOS: Software Interrupt #


		pseg	cdosexterr

;/*
;**  int
;** dosexter(int *errorclass,int *suggestedaction,int *locus)
;**
;** ARGUMENT(s)
;**  errorclass 	 -	 points to int that receives error class value
;**  suggestedaction	 -	 points to int that receives suggested action value
;**  locus		 -	 points to int that receives locus
;**
;** DESCRIPTION
;**  Provides interface with DOS function 0x59 (Get Extended Error).  This
;**  function is available in versions 3.00 and above.
;**
;**
;** RETURNS
;**  Extended error
;**
;** AUTHOR
;**  ""   Wed 07-Dec-1988	10:02:55
;**   Copyright (C)1988-1990 Greenleaf Software Inc. All Rights Reserved.
;**
;** MODIFICATIONS
;**
;*/

		cproc	dosexter
		push	ds
		mov    ah,GETEXTERROR
		int    DOSCALL
		mov    dx,ax		       ;save extended error in DX
		if	_LDATA
		 lds	si,parm1_		;DS:SI points to errorclass
		 mov	ax,ds
		 or	ax,si			;is it NULL?
		 jz	skip1
		 mov	[si],bh 		;save error class at DS:SI
skip1:		 lds	si,parm3_		;DS:SI points to suggested action
		 mov	ax,ds
		 or	ax,si			;is it NULL?
		 jz	skip2
		 mov	[si],bl 		;save suggested action
skip2:		 lds	si,parm5_		;DS:SI points to locus
		 mov	ax,ds
		 or	ax,si			;is it NULL
		 jz	skip3
		 mov	[si],ch 		;save locus
skip3:
		else
		 mov	si,parm1_		;DS:SI points to errorclass
		 or	si,si
		 jz	skip1
		 mov	[si],bh 		;save error class at DS:SI
skip1:		 mov	si,parm2_		;DS:SI points to suggested action
		 or	si,si			;is it NULL?
		 jz	skip2
		 mov	[si],bl 		;save suggested action
skip2:		 mov	si,parm3_		;DS:SI points to locus
		 or	si,si			;is it NULL
		 jz	skip3
		 mov	[si],ch 		;save locus
skip3:
		endif
		mov    ax,dx		       ;get extended error back from DX
		pop	ds
		cproce

		endps
		end
