		page	58,132
;
; equip.asm
; contains: equip()
;
		include	model.h
		include	prologue.h
		name	equip
		pseg	equip

;==>--	unsigned equip(void)
;
;;	DESCRIPTION:
;	  Does ROM-BIOS interrupt 0x11 to determine installed equipment
;
;;	RETURNS:
;	  16 bit value, indicating installed hardware
;
;		BITS	MEANING
;
;		15,14	no. printers installed 0..3
;		   12	game I/O  (0=no, 1=yea)
;	      11,10,9	no. RS232 cards installed 0..7
;       	  7,6   no. diskette drives: zero If bit 0 = 0, or
;			00=1 01=2 10=3 11=4 (If bit 0 = 1)
;		  5,4   initial video mode:
;					01 = 40x25 b/w, with color card
;					10 = 80x25 b/w, color card
;					11 = 80x25 b/w, monochrome card
;		    0	0=no diskettes, 1=some diskettes installed.
;
;;	AUTHOR:
;	  Copyright (C)1987-1990 Greenleaf Software Inc. All Rights Reserved.
;
;;;
	cproc	equip
	int	11h
	cproce	

;==>--	int memsize(void)
;
;;	DESCRIPTION:
;	  Determines number of contiguous 1K blocks of memory known to
;	  Rom-Bios Interrupt 0x12
;
;;	RETURNS:
;	  Number of contiguous 1K blocks of memory
;
;;	AUTHOR:
;	  Copyright (C)1987-1990 Greenleaf Software Inc. All Rights Reserved.
;;;
	cproc	memsize
	int	12h		; BIOS gets data which was set at
	cproce			;  power-on diagnostic time.

;==>--	void putverify(control)
;
;;	ARGUMENTS:
;	  (int)		control	-	ON(1)	verify on
;					OFF(0)	verify off
;;	DESCRIPTION:
;	  Set/Clear DOS verify switch.
;
;;	SIDE EFFECTS:
;	  verify switch changed.
;
;;	AUTHOR:
;	  Copyright (C)1987-1990 Greenleaf Software Inc. All Rights Reserved.
;;;
	cproc	putverify,,putverif
	mov	ax,parm1_	; get argument (0=OFF, 1=ON)
	mov	ah,2Eh
	int	21h		; do it
	cproce

;==>--	int getverify(void)
;
;;	ARGUMENTS:
;	  (none)
;
;;	DESCRIPTION:
;	  Get setting of DOS verify switch
;
;;	RETURNS:
;	  ON(1) if verify on, OFF(0) if verify off.
;
;;	AUTHOR:
;	  Copyright (C)1987-1990 Greenleaf Software Inc. All Rights Reserved.
;;;
	cproc	getverify,,getverif
	mov	ax,5400h
	int	21h		; sets AL=0=OFF, 1=ON
	xor	ah,ah		; whole return in AL
	cproce
	endps
	end
