/*
 * equipmen.c
 * contains: equipment()
 *
 */

#include <stdio.h>
#include "gfuncts.h"

/*
 *  unsigned
 * equipment(kind)
 *
 * ARGUMENT
 *  (unsigned)	kind	=	Type specifier
 *
 * DESCRIPTION
 *  Based on parameter (kind) finds out the quantity of the specified
 *  type of equipment installed in the PC.
 *
 * RETURNS
 *  Quantity or mode (see ARGUMENT)
 *
 * AUTHOR
 *   Copyright (C)1987-1990 Greenleaf Software Inc. All Rights Reserved.
 */
int GF_CONV equipment(kind)
int kind;
{
	unsigned what;
	int iret;

	what=equip();
	switch (kind) {
	case 1:
		if(!what&0x0001)
			return 0;
		else 
			return(int)(((what&0x00C0)>>6)+1);
	case 2:
		return(int)(((what&0xC000)>>14)&7);
	case 3:
		return(int)((what&0x0E00)>>9);
	case 4:
		return(int)((what&0x1000)>>12);
	case 0:
		iret=(int)(what&0x30)>>4;
		if(iret==1)
			return 0;
		else if(iret==3)
			return 7;
		else 
			return iret;
	}
	return 0;
}
