/*
 * fgetfld.c
 * contains: fgetfield()
 *
 */

#include <stdio.h>
#include "gfuncts.h"

/*
 *  int
 * fgetfield(dest,stream,width)
 *
 * ARGUMENT
 *  (char *)	dest	=	pointer to destination string
 *  (FILE *)	stream	=	File stream pointer
 *  (int)	width	=	Number of characters in field
 *
 * DESCRIPTION
 *  Characters are read from the indicated stream to the destination
 *  string.  The number of characters transferred is the lesser of
 *  "width" or the remainder of the file.  Newlines and other field
 *  delineators are not regognized.  The destination is terminated.
 *
 * RETURNS
 *  Number of characters transferred, 0 if EOF read.
 *
 * AUTHOR
 *   Copyright (C)1987-1990 Greenleaf Software Inc. All Rights Reserved.
 */
int GF_CONV fgetfield(pd,fi,count)
char *pd;
FILE *fi;
int count;
{
	int fret,i,chs;

	chs=0;
	for(i=1;i<=count;i++) {
		fret=fgetc(fi);
		if(fret==EOF)
			return 0;
		else {
			*pd++ = (char)fret;
			++chs;
		}
	}
	*pd='\0';
	return chs;
}
