/*
 * getcount.c
 * contains: getcountry()
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "gfuncts.h"

/*
 *  char *
 * getcountry(void)
 *
 * DESCRIPTION
 *  Country dependent data is read from DOS and converted to a string
 *  describing it.
 *
 * RETURNS
 *  Pointer to string if successful, otherwise NULL
 *
 * AUTHOR
 *   Copyright (C)1987-1990 Greenleaf Software Inc. All Rights Reserved.
 *
 * MODIFICATIONS
 *
 */
char* GF_CONV getcountry()
{
	char *p,*buf,ci,*buf2,*_c_str,*s1;
	unsigned ver,rev;
	struct GFREGS in,out;
	int *pi;
		
	_c_str=NULL;
	ver=dosversion()&0x00ff;
	rev=(dosversion()>>8)&0x00ff;
	if (ver==0||(ver==2&&rev<1)) {
		strcpy(_c_str,"Cannot Get Country Info - DOS is Pre-2.10");
		return _c_str;
	}
	if((buf=malloc(64))==NULL||(_c_str=malloc(250))==NULL||
	   (buf2=malloc(60))==NULL)
		return((char *)0);
	in.dx=(int)ofsspu(buf);
	in.ds=(int)segspu(buf);
	in.ax=0x3800;
	if(sysint(0x21,&in,&out)&1) {
		strcpy(_c_str,"ERROR IN GETTING COUNTRY INFORMATION");
		return _c_str;
	}
	pi=(int *)buf;
	strcpy(_c_str,"TimeDate Format: ");
	switch (*pi) {
		case 0:
			s1="USA (h:m:s m/d/y)";
			break;
		case 1: 
			s1="Europe (h:m:s d/m/y)"; 
			break;
		case 2: 
			s1="Japan (h:m:s d:m:y)"; 
			break;
		default: 
			s1="Indeterminate."; 
			break;
	}
	strcat(_c_str,s1);
	p=buf+2;
	strcat(_c_str,"\nCurrency symbol ");
	strcat(_c_str,p);
	p+=(ver==2)?2:5;
	strcat(_c_str,"\nThousands separator ");
	strcat(_c_str,p);
	p+=2;
	strcat(_c_str,"\nDecimal separator ");
	strcat(_c_str,p);
	strcat(_c_str,"\n");
	if (ver==3) {
		sprintf(buf2,"Country code %d",out.bx);
		strcat(_c_str,buf2);
		p+=2;
		strcat(_c_str,"\nDate separator ");
		strcat(_c_str,p);
		p+=2;
		strcat(_c_str,"\nTime separator ");
		strcat(_c_str,p);
		p+=3;
		sprintf(buf2,
			"\nSignificant decimal digits in currency %d\n",
			(int)*p);
		strcat(_c_str,buf2);
		++p;
		ci = *p;
		if((ci&1) ==0) 
			strcat(_c_str,"12");
		else 
			strcat(_c_str,"24");
		strcat(_c_str," Hour Clock\n");
	}
	free(buf);
	free(buf2);
	return _c_str;
}
