;/*
;** getexmem.asm
;** contains: getexmem()
;*/

SYSSERVICE	equ	015h			;System Service Software Interrupt
GETEXTMEM	equ	088h			;Extended Memory Size Determine


		include model.h
		include prologue.h

		pseg pgetexmem


;/*
;**  unsigned 
;** getexmem(void)
;**
;** ARGUMENT(s)
;**  none
;**
;** DESCRIPTION
;**  Determine memory above 100000h
;**
;**
;** RETURNS
;**  Number of 1K (1024) blocks of memory available beginning at
;**  address 100000h.
;**
;** AUTHOR
;**  ""   Tue 15-Nov-1988	14:05:40
;**   Copyright (C)1988-1990 Greenleaf Software Inc. All Rights Reserved.
;**
;** MODIFICATIONS
;**
;*/
		cproc	getexmem
		mov	ah,GETEXTMEM
		int	SYSSERVICE
		jnc	funcsupported
		xor	ax,ax			;say 0 if not supported
funcsupported:
		cproce

		endps
		end
