;/*
;** getpsp.asm
;** contains: getpsp()
;*/

GETPSPADDRESS		equ	062h		;Get Program Segment Prefix Address
DOSCALL 		equ	021h		;DOS Software Interrupt

		include model.h
		include prologue.h

		pseg	pGetPsp

;/*
;**  GPSPINFO far *
;** getpsp(void)
;**
;** ARGUMENT(s)
;**  none
;**
;** DESCRIPTION
;**  Calls DOS for the address of the program segment prefix (PSP).  This
;**  function is only supported in DOS versions later than 3.00.
;**
;** RETURNS
;**  far pointer to a structure named GPSPINFO, defined in gpsp.h.
;**
;** AUTHOR
;**  ""   Mon 14-Nov-1988	15:48:36
;**   Copyright (C)1988-1990 Greenleaf Software Inc. All Rights Reserved.
;**
;** MODIFICATIONS
;**
;*/
		cproc	getpsp
		mov	ah,GETPSPADDRESS
		int	DOSCALL
		ifdef	AXBX32
		 mov	ax,bx			;AX gets segment
		 xor	bx,bx			;BX (offset) = 0
		else
		 mov	dx,bx			;DX gets segment
		 xor	ax,ax			;AX (offset) = 0
		endif
		cproce

		endps
		end
