/*
 * gpaint.c
 * contains: gpaint()
 *
 */

#include <stdio.h>
#include "gfuncts.h"

/*
 *  void
 * gpaint(urow,lcol,lrow,rcol,background,foreground)
 *
 * ARGUMENT
 *  (int)	urow	-	Upper row
 *  (int)	lcol	-	Left-most column
 *  (int)	lrow	-	Lower most row
 *  (int)	rcol	-	Rightmost column
 *  (int)	background -	Color or attribute for background
 *  (int)	foreground -	Foreground attribute or color
 *
 * DESCRIPTION
 *  Paint text screen area background color or attribute.  Caution
 *  calls upscroll()!
 *
 * AUTHOR
 *   Copyright (C)1987-1990 Greenleaf Software Inc. All Rights Reserved.
 */
void GF_CONV gpaint(urow,lcol,lrow,rcol,fgnd,bkgnd)
int urow,lcol,lrow,rcol,fgnd,bkgnd;
{
	unsigned attr;

	attr=((unsigned)bkgnd<<4)|(unsigned)fgnd;
	upscroll(0,urow,lrow,lcol,rcol,(int)attr);
}
