/*
 * gprintf.c
 * contains: gprintf()
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include "gfuncts.h"

/*
 *  void
 * gprintf(fmt,args,)
 *
 * ARGUMENT
 *  (char *)	fmt	-	format string for sprintf()
 *  (unsigned)	args	-	arguments for sprintf()
 *
 * DESCRIPTION
 *   This function uses sprintf() to format up to about 20 int arguments or
 *   five floating point args.  Note that we just pass some words on the
 *   stack and really do not care what data types are actually being used.
 *   Hence, you may experience problems with large numbers of arguments.
 *   If your compiler supports larger numbers of arguments passed for a
 *   function, you may extend this just by adding, e.g. a21, a22,... in
 *   three places.
 *   We just print the resultant string using putcinc() which uses ROM
 *   BIOS to display the characters and increment the cursor.
 *
 * AUTHOR
 *   Copyright (C)1987-1990 Greenleaf Software Inc. All Rights Reserved.
 *
 * MODIFICATIONS
 *
 */
#ifndef	_MSC
void GF_CDECL gprintf(fmt)
#else
#if	_MSC > 4
void GF_CDECL gprintf(fmt,...)
#else
void gprintf(fmt)
#endif
#endif

char *fmt;
{
	void GF_CONV putcinc();
	char *buf;
	register char *p;
	char **value;

	value=&fmt;
	if((buf=malloc(200))==NULL)
		return;
	sprintf(buf,fmt,
		value[1],value[2],value[3],value[4],value[5],value[6],
		value[7],value[8],value[9],value[10]
#ifndef _LDATA
		,value[11],value[12],value[13],value[14],value[15],value[16],
		value[17],value[18],value[19],value[20]
#endif
		);
	p=buf;
	while(*p) {
		putcinc(*p,7,0);
		++p;
	}
	free(buf);
}
