;/*
;** inptokbb.asm
;** contains:
;*/

KEYBOARDWRITE	equ	05h			;ROM-BIOS Keyboard write function
KEYBOARDINT	equ	16h			;Keyboard software interrupt #

		include model.h
		include prologue.h

		pseg inptokb

;/*
;**  int
;** inptokbb(unsigned ScanChar)
;**
;** ARGUMENT(s)
;**  ScanChar		-	Scan code in high order 8 bits,
;**				character code in low order 8 bits.
;**
;** DESCRIPTION
;**  For AT BIOS dated 11/15/85 and after, PC XT dated 1/10/86 and after,
;**  PC XT Model 286, and Personal System/2 products, this function places
;**  scan code/character code combination in the keyboard buffer as if they
;**  came from the keyboard.  NOTE: This function uses the keyboard bios
;**  interrupt.
;**
;** RETURNS
;**  0 = operation successfully completed.
;**  1 = Buffer is full.
;**
;** AUTHOR
;**  ""   Fri 11-Nov-1988	09:42:50
;**   Copyright (C)1988-1990 Greenleaf Software Inc. All Rights Reserved.
;**
;** MODIFICATIONS
;**
;*/
		cproc	inptokbb
		mov	cx,parm1_		;ch=scan code, cl=ascii code
		mov	ah,KEYBOARDWRITE
		int	KEYBOARDINT		;call keyboard code
		xor	ah,ah			;status returns in al
		cproce

		endps
		end
