/*
 * islxx.c
 * contains: isleap(), isletter()
 *
 *   Copyright (C)1987-1990 Greenleaf Software Inc. All Rights Reserved.
 */

#include <stdio.h>
#include "gfuncts.h"

/*
 *  bool
 * isleap(year)
 *
 * ARGUMENT
 *  (int)	year	-	year to test
 *
 * DESCRIPTION
 *  Determine if specified year is a leap year.
 *
 * RETURNS
 *  TRUE if is leap year, else FALSE
 */
bool GF_CONV isleap(year)
int year;
{
	return(year%4==0&&year%100!=0||year%400==0);
}

/*
 *  bool
 * isletter(c)
 *
 * ARGUMENT
 *  (char)	c	-	character to test
 *
 * DESCRIPTION
 *  Tests character for alphabetic or underline
 *
 * RETURNS
 *  TRUE if character is alphabetic or underline else FALSE
 */
bool GF_CONV isletter(c)
char c;
{
	return ((c>='a'&& c<='z')||(c>='A'&&c<='Z')||c=='_');
}
