		page	58,132

; kbd.asm
; contains: getkey(), gfkbhit(), kbfetch(), kbshift(),breakchk(),enhkbd()
;
;
		ifndef	_LCODE
		 include	model.h
		endif
		include	prologue.h
		name	kbd

;;	AUTHOR:
;	 ""   21-OCT-1984  09:22:58.57
;	  Copyright (C)1984-1990 Greenleaf Software Inc. All Rights Rerserved.
;
;;	MODIFICATIONS:
;	 ""   12-JAN-1989  16:23:45.90
;	  Removed translate table for getkey()
;;;

	dseg	kbd

kstfunc	db	1		;keyboard status function #
sstfunc	db	2		;shift status function #
kinfunc	db	0		;input function #

	ifdef	HIGHC
	if	_LCODE
trapptr	dw	offset trfunc
	else
trapptr	dw	offset cgroup:trfunc
	endif

	else
trapptr	dw	offset trfunc
	endif

 	endds

	pseg	getkey
i23off	dw	0
i23seg	dw	0
bchkv	db	0ffh		;keeps track of last breakchk() value
				;SET.  When 0FFH it means vector has
				;not yet been re-directed.  If
				;it == 0 then don't abort, if == 1
				;abort.

;==>--	unsigned getkey(void)
;
;;	ARGUMENTS:
;	 (none)
;
;;	DESCRIPTION:
;	  Get keyboard code without echo.
;
;;	SIDE EFFECTS:
;	  none
;
;;	RETURNS:
;	  8-bit standard ASCII code (0x00-0x7f) or predefined extended code
;	  per ibmkeys.h
;
;;	AUTHOR:
;	  Copyright (C)1987-1990 Greenleaf Software Inc. All Rights Reserved.
;
;;	MODIFICATIONS:
;	 ""   12-JAN-1989  16:27:24.22
;	  Removed translate table for getkey()
;;;
	cproc	getkey
	call	[trapptr]
	mov	ah,kinfunc
	int	16h		;rom bios keyboard input
	or	ax,ax		;is it Ctrl-Break ?
	jz	short gtkyex 	;if so return ax=0 for control break

	cmp	al,0e0h		;from second set of keys?
	jnz	noaltk
	xor	al,al
noaltk:	or	al,al		;is it extended ?
	jz	gtkyex		;return it if so
	xor	ah,ah		;else return character in AL, clear AH
gtkyex: 
	call	doschk
	cproce

;==>--	bool gfkbhit(void)
;
;;	ARGUMENTS:
;	 (none)
;
;;	DESCRIPTION:
;	 Test keyboard for activity via ROM-BIOS and return result
;
;;	SIDE EFFECTS:
;	 (none)
;
;;	RETURNS:
;	 TRUE (1) if keyboard code available, else FALSE (0)
;
;;	AUTHOR:
;	  Copyright (C)1987-1990 Greenleaf Software Inc. All Rights Reserved.
;
;;	MODIFICATIONS:
;
;;;
	cproc	gfkbhit
	call	[trapptr]	
	mov	ah,kstfunc
	int	16h		;rom-bios get keyboard status
	mov	ax,1
	jnz	havcod
	xor	ax,ax		;say no keyboard activity
havcod:	cmp	kstfunc,11h
	jz	skpchk		;if new style skip next call
	call	doschk
skpchk:
	cproce			; or return code in AL/AH

;==>--	unsigned kbfetch(void)
;
;;	ARGUMENTS:
;	 (none)
;
;;	DESCRIPTION:
;	  One character is fetched from the keyboard FIFO buffer via
;	  ROM-BIOS.  If the buffer is empty, this routine waits until
;	  a key is struck.
;
;;	SIDE EFFECTS:
;	  (none)
;
;;	RETURNS:
;	  ASCII code (low-byte), Keyboard Scan Code (high byte)
;
;;	AUTHOR:
;	  Copyright (C)1987-1990 Greenleaf Software Inc. All Rights Reserved.
;
;;	MODIFICATIONS:
;
;;;
	cproc	kbfetch
	call	[trapptr]	
	mov	ah,kinfunc
	int	16h		;rom bios keyboard input
	call	doschk
	cproce

;==>--	unsigned kbshift(void)
;
;;	ARGUMENTS:
;	  (none)
;
;;	DESCRIPTION:
;	  Get current status of keyboard shift keys via ROM-BIOS.
;
;;	SIDE EFFECTS:
;	  (none)
;
;;	RETURNS:
;	  status of keyboard shift keys.
;
;;	AUTHOR:
;	 ""   25-MAR-1987  09:44:45.84
;	  Copyright (C)1987-1990 Greenleaf Software Inc. All Rights Reserved.
;
;;	MODIFICATIONS:
;
;;;
	cproc	kbshift
	call	[trapptr]	
	mov	ah,sstfunc
	int 	16h
	cproce

;==>--	int breakchk(control)
;
;;	ARGUMENTS:
;	 (int)	control	-	OFF(0),ON(1),or (2)
;				ON  = do not install ctrl break handler
;				OFF = install ctrl-break handler so user
;				      program will not exit with ctrl-break
;				2   = Return current state (ON/OFF)
;
;;	DESCRIPTION:
;	  Control/Status of control break function.
;
;;	SIDE EFFECTS:
;	  If called with OFF as a parameter the control break handler
;	  in this file will be installed.
;
;;	RETURNS:
;	  1 if control break is ON, else 0
;
;;	AUTHOR:
;	  Copyright (C)1987-1990 Greenleaf Software Inc. All Rights Reserved.
;
;;	MODIFICATIONS:
;
;;;
	cproc	breakchk
	mov	ax,@ab[bp]	;see what user wants 0..2
	mov	ah,al		;save in ah for later
	cmp	al,2
	jb	brkset
	jz	jstchk
	or	ax,-1		;else return error
	jmp	short bcxit
jstchk:	mov	ax,3300h	;yes,check
	int	21h
	xor	ah,ah		;return AL
	mov	al,dl
	jmp	short bcxit
brkset:	cmp	cs:bchkv,0ffh ;see if vector has been re-directed
	jnz	bc1_ok
	call	seti23	;if not re-direct to our code!
bc1_ok:	mov	dl,ah		;set it  off
	xor	dh,dh		;save return value
	push	dx
	mov	ax,3301h
	int	21h
	pop	ax		;saved as dx
	mov	cs:bchkv,al	;save in variable for ctrl-break also
bcxit:
	cproce

;==>--	int enhkbd(void)
;
;;	ARGUMENTS:
;	 (none)
;
;;	DESCRIPTION:
;	 Determines if enhanced keyboard is installed.
;
;;	SIDE EFFECTS:
;	 (none)
;
;;	RETURNS:
;	 1 = Enhanced keyboard is installed, 0 = Not installed
;
;;	AUTHOR:
;	 ""   25-MAR-1987  10:03:02.90
;	  Copyright (C)1987-1990 Greenleaf Software Inc. All Rights Reserved.
;
;;	MODIFICATIONS:
;
;;;
	cproc	enhkbd
	call	enkbck
	cproce

;==>--	void _disenk(void)
;
;;	ARGUMENTS:
;	  (none)
;
;;	DESCRIPTION:
;	  Disables check/adjustment for enhanced keyboard
;
;;	SIDE EFFECTS:
;	  enhanced keyboard will not be detected, must be called before
;	  any other keyboard functions.
;
;;	RETURNS:
;	  (void)
;
;;	AUTHOR:
;	 ""   25-MAR-1987  10:04:48.48
;	  Copyright (C)1987-1990 Greenleaf Software Inc. All Rights Reserved.
;
;;	MODIFICATIONS:
;
;;;
	cproc	_disenk
	ifdef	HIGHC
	if	_LCODE
	mov	trapptr,offset trfret
	else
	mov	trapptr,offset cgroup:trfret
	endif
	else
	mov	trapptr,offset trfret
	endif
	cproce

;==>--	doschk	is a procedure used only by functions in this file
;	it makes a dos call to give dos an oppurtunity to terminate
;	the current program.
;
doschk	proc	near
	cmp	byte ptr cs:bchkv,0
	je	doscex
	push	ax
	mov	ah,0bh		;check keyboard status via DOS
	int	21h		;this gives dos an oppurtunity to exit
	pop	ax
doscex:	ret
doschk	endp

;==>--	INT 23 (control break) HANDLER
;
;  Interrupt 23h is re-directed to here if breakchk(0||1) is called
;
;
i23hnd	proc	far
	test	byte ptr cs:bchkv,0ffh
	jz	not_brk
int23_brk:
	jmp	dword ptr cs:i23off
not_brk:clc
	ret	2
i23hnd	endp

;==>--	Save current int 23h & Re-direct interrupt 23 to the i23hnd
;
seti23	proc	near
	push	ax		;ah has something 
	push	ds
	push	es
	mov	ax,3523h	;get vector to es:bx
	int	21h
	mov	cs:i23off,bx
	mov	cs:i23seg,es
	mov	ax,cs
	mov	ds,ax
	ifdef	HIGHC
	 if	_LCODE
	  mov	dx,offset i23hnd
	 else
	  mov	dx,offset cgroup:i23hnd
	 endif
	else
	 mov	dx,offset i23hnd
	endif
	mov	ax,2523h	;set interrupt #23h
	int	21h
	pop	es
	pop	ds
	pop	ax
	ret
seti23	endp


enkbck	proc	near
	push	ds
	mov	ax,40h
	mov	ds,ax
	mov	bx,96h
	mov	bl,[bx]
	pop	ds
	xor	ax,ax		;assume not installed
	and	bl,10h
	jz	enot
	inc	ax
enot:	ret
enkbck	endp

trfunc	proc	near
	ifdef	HIGHC
	if	_LCODE
	mov	trapptr,offset trfret
	else
	mov	trapptr,offset cgroup:trfret
	endif
	else
	mov	trapptr,offset trfret
	endif
	call	enkbck
	or	ax,ax			;if enhanced kbd not installed skip
	jz	trfret
	mov	ah,10h
	or	kstfunc,ah
	or	sstfunc,ah
	or	kinfunc,ah
trfret:	ret
trfunc	endp
	endps
	end
