/*
** openprnt.c
** contains: openprt(),closeprt()
*/

#include <stdio.h>
#include <stdlib.h>
#include "gf.h"
#include "gfuncts.h"
#include "parint.h"

PARINT irq7state = {
	{1,0,0,0},		/* Status Bits */
	0x3bc,			/* Base I/O Address for LPT1 */
	0x0f,			/* Interrupt Number */
	(unsigned long)0,	/* Previous vector contents */
	0,			/* Previous contents of IRQ enable port */
	7,			/* IRQ # in 8259 */
	0,			/* Previous contents of bit in 8259 */
	0x20,			/* I/O Address of 8259 */
	0,			/* Buffer Size */
	0,			/* Number of characters in buffer */
	0,			/* Buffer head */
	0,			/* Buffer Tail */
	(unsigned char *)0,	/* Buffer */
};


/*
**  PARINT *
** openprt(unsigned buffersize)
**
** ARGUMENT(s)
**	buffersize	-	Size of the buffer to be allocated.
**
** DESCRIPTION
**
**
**
** RETURNS
**  Pointer to PARINT structure if successful, else returns (PARINT *)0
**  if unable to allocate memory for buffer.
**
** AUTHOR
**  ""   Wed 16-Nov-1988  16:17:16
**   Copyright (C)1988-1990 Greenleaf Software Inc. All Rights Reserved.
**
** MODIFICATIONS
**
*/
PARINT * GF_CONV openprt(buffersize)
unsigned buffersize;
{
	PARINT *p;
        unsigned short far *parbase=(unsigned short far *)0x00400008;

	p=&irq7state;
	p->StatusBits.bufferfull=p->StatusBits.intsrunning=0;
	p->StatusBits.intsenabled=p->StatusBits.bufferempty=1;
	p->pBufSize=buffersize;
        p->pBufCount=p->pBufHead=p->pBufTail=0;
        p->BaseIOPARO=*parbase;
        if(!p->BaseIOPARO)
                return((PARINT *)0);
	if((p->pBuffer=(unsigned char *)malloc(buffersize))==(unsigned char *)0)
                return((PARINT *)0);
	_setpari(p);
	return(p);
}


/*
**  void
** closeprt(PARINT *p)
**
** ARGUMENT(s)
**	p	-	points to the PARINT structure returned by OpenPrinter.
**
** DESCRIPTION
**  Shuts down printer interrupt, free's buffer malloc'ed in OpenPrinter().
**
**
** RETURNS
**  void
**
** AUTHOR
**  ""   Wed 16-Nov-1988  16:55:52
**   Copyright (C)1988-1990 Greenleaf Software Inc. All Rights Reserved.
**
** MODIFICATIONS
**
*/
void GF_CONV closeprt(p)
PARINT *p;
{
	p=&irq7state;
	_closepar(p);
	p->StatusBits.bufferfull=p->StatusBits.intsrunning=0;
	p->StatusBits.intsenabled=p->StatusBits.bufferempty=1;
	p->pBufSize=0;
	p->pBufCount=p->pBufHead=p->pBufTail=0;
	free((char *)p->pBuffer);
	p->pBuffer=(unsigned char *)0;
	return;
}
