/*
 * prs.c
 * contains: cprs(),jprs(),prf(),cprf(),jprf(),
 *
 *   Copyright (C)1987-1990 Greenleaf Software Inc. All Rights Reserved.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include "gfuncts.h"


/*
 *  void
 * cprs(cols,string)
 *
 * ARGUMENT
 *  (int)	cols	=	Number of columns to center on
 *  (char *)	string  =	Pointer to string to print
 *
 * DESCRIPTION
 *  Data is centered via centers() and output via prs().
 */
void GF_CONV cprs(cols,str)
char *str;
int cols;
{
	char *buf;

	if((buf=malloc(200))==NULL)
		return;
	centers(buf,str,cols);
	prs(buf);
	free(buf);
}

/*
 *  bool
 * jprs(cols,str)
 *
 * ARGUMENT
 *  (int)	cols	=	Number of columns to justify on
 *  (char *)	str	=	pointer to string to print
 *
 * DESCRIPTION
 *  Data is justified on a line and printed via prs().
 *
 * RETURNS
 *  TRUE(1) if justification successful, else FALSE(0)
 */
bool GF_CONV jprs(width,str)
char *str;
int width;
{
	char *buf;
	bool iret;

	if((buf=malloc(200))==NULL)
		return(FALSE);
	iret=justify(buf,str,width);
	prs(buf);
	free(buf);
	return iret;
}

/*
 *  void
 * prf(format,args,)
 *
 * ARGUMENT
 *  (char *)	format	=	pointer to format string for sprintf()
 * 		args	=	arguments for sprintf()
 *
 * DESCRIPTION
 *  Arguments are formatted by sprintf to an internal 200 character buffer
 *  then printed via prs().
 */
#ifndef	_MSC
void GF_CDECL prf(format)
#else
#if	_MSC > 4
void GF_CDECL prf(format,...)
#else
void prf(format)
#endif
#endif

char *format;
{
	char *buf,**value;
	
	value=&format;
	if((buf=malloc(200))==NULL)
		return;
	sprintf(buf,format,
		value[1],value[2],value[3],value[4],value[5],value[6],
		value[7],value[8],value[9],value[10]
#ifndef _LDATA
		,value[11],value[12],value[13],value[14],value[15],value[16],
		value[17],value[18],value[19],value[20]
#endif
	        );
	prs(buf);
	free(buf);
}

/*
 *  void
 * cprf(cols,format,args,)
 *
 * ARGUMENT
 *  (int)	cols	=	Number of columns to center on
 *  (char *)	format	=	format string for sprintf()
 *		args	=	arguments for sprintf()
 *
 * DESCRIPTION
 *  Data is formatted via sprintf() and then output via cprs().
 */
#ifndef	_MSC
void GF_CDECL cprf(cols,format)
#else
#if	_MSC > 4
void GF_CDECL cprf(cols,format,...)
#else
void cprf(cols,format)
#endif
#endif

int cols;
char *format;
{
	char *buf,**value;
	
	value=&format;
	if((buf=malloc(200))==NULL)
		return;
	sprintf(buf,format,
		value[1],value[2],value[3],value[4],value[5],value[6],
		value[7],value[8],value[9],value[10]
#ifndef _LDATA
		,value[11],value[12],value[13],value[14],value[15],value[16],
		value[17],value[18],value[19],value[20]
#endif
		);
	cprs(cols,buf);
	free(buf);
}

/*
 *  bool
 * jprf(cols,format,args,)
 *
 * ARGUMENT
 *  (int)	cols	=	Number of columns to justify on
 *  (char *)	format	=	format string for sprintf()
 *  		args	=	arguments for sprintf
 *
 * DESCRIPTION
 *  Data is formatted via sprintf(), then justified and printed via
 *  jprs().
 *
 * RETURNS
 *  TRUE if successful, FALSE if unable to allocate memory or unable
 *  to justify.
 */

#ifndef	_MSC
bool GF_CDECL jprf(cols,format)
#else
#if	_MSC > 4
bool GF_CDECL jprf(cols,format,...)
#else
bool jprf(cols,format)
#endif
#endif

int cols;
char *format;
{
	char *buf;
	bool bret;
	char **value;
	
	value=&format;
	if((buf=malloc(200))==NULL)
	    return(FALSE);
	sprintf(buf,format,
		value[1],value[2],value[3],value[4],value[5],value[6],
		value[7],value[8],value[9],value[10]
#ifndef _LDATA
		,value[11],value[12],value[13],value[14],value[15],value[16],
		value[17],value[18],value[19],value[20]
#endif
		);
	bret=jprs(cols,buf);
	free(buf);
	return bret;
}
