/*
 * puthexw.c
 * contains: puthexw(),puthexc(),puthexs()
 *
 *   Copyright (C)1987-1990 Greenleaf Software Inc. All Rights Reserved.
 *
 */

#include <stdio.h>
#include "gfuncts.h"

/*
 *  void
 * puthexc(chr)
 *
 * ARGUMENT
 *  (char)	chr	=	character (byte) to print in hex.
 *
 * DESCRIPTION
 *  print character in hexadecimal format via putchar()
 */
void GF_CONV puthexc(chr)
char chr;
{
	char a[2];
	int i;

	a[0]=(char)((chr & 0x00F0)>>4);
	a[1]=(char)(chr&0x000F);
	for(i=0;i<=1;i++) {
		if(a[i]<=9)
			putchar(a[i]+'0');
		else 
			putchar((a[i]-10+'A')&0x4F);
	}
}

/*
 *  void
 * puthexw(word)
 *
 * ARGUMENT
 *  (unsigned) word	=	16 bit value to display in hex
 *
 * DESCRIPTION
 *  print 16 bit value in hex via puthexc().
 */
void GF_CONV puthexw(wd)
int wd;
{
	int hi;
	hi=(wd&0xFF00)>>8;
	puthexc((char)(wd&0xFF));
	puthexc((char)hi);
}

/*
 *  void
 * puthexs(string)
 *
 * ARGUMENT
 *  (char *)	string	=	pointer to string to output in hex
 *
 * DESCRIPTION
 *  This function outputs a null terminated string of characters in
 *  hex via puthexc().
 */
void GF_CONV puthexs(str)
char *str;
{
	char c;
	while((c=*str++)!=0) {
		puthexc(c);
		putchar(' ');
	}
}
