/*
** restscrn.c
** contains: restscrn()
*/

#include <stdio.h>
#include <stdlib.h>
#include "gfuncts.h"



#ifndef _MSC
#ifndef	TURBOC
	int fwrite();
#endif
#endif


/*
**  int
** restscrn(char *filename)
**
** ARGUMENT(s)
**  filename	-	filename of file to be displayed
**
** DESCRIPTION
**  Restores screen image from a file.	This must have been written with
**  savscrn().
**
** RETURNS
**	GFSUCCESS,
**	NOTENOUGHMEMORY,
**	CANTOPENFILE,
**	CANTREADFILE,
**	INVALIDFILE,
**
** AUTHOR
**  "" Wed 21-Dec-1988 14:51:29
**   Copyright (C)1988-1990 Greenleaf Software Inc. All Rights Reserved.
**
** MODIFICATIONS
**
*/
int GF_CONV restscrn(filename)
char *filename;
{
	char *opstring;
	union GFSCRNFILE *gfshdr=(union GFSCRNFILE *)0;
	unsigned *screenimage=(unsigned *)0;
	FILE *fp=(FILE *)0;
	int retval=GFSUCCESS;

#ifndef	AZTEC		
	opstring="rb";
#else
	opstring="r";
#endif
	if((gfshdr=(union GFSCRNFILE *)calloc(sizeof(union GFSCRNFILE),1))==(union GFSCRNFILE *)0)
		return(NOTENOUGHMEMORY);
	if((fp=fopen(filename,opstring))==(FILE *)0)
		retval=CANTOPENFILE;
	if(!retval && fread((char *)gfshdr,sizeof(union GFSCRNFILE),1,fp)!=1)
		retval=CANTREADFILE;
	if(!retval && (gfshdr->f.gffileid!=SCRNFILID||
	   gfshdr->f.gffileid+gfshdr->f.gfuversion+gfshdr->f.gfurevision!=gfshdr->f.gfsumcheck))
		retval=INVALIDFILE;
	if(!retval && (screenimage=(unsigned *)malloc((gfshdr->f.gfrows*gfshdr->f.gfcols)*2))==(unsigned *)0)
		retval=NOTENOUGHMEMORY;
	if(!retval && fread((char *)screenimage,gfshdr->f.gfreadsize,1,fp)!=1)
		retval=CANTREADFILE;

	putscrn(0,0,gfshdr->f.gfrows-1,gfshdr->f.gfcols-1,screenimage);
	curset(gfshdr->f.gfcurrow,gfshdr->f.gfcurcol,0);
	if(fp)
		fclose(fp);
	if(screenimage)
		free((char *)screenimage);
	if(gfshdr)
		free((char *)gfshdr);
	return(retval);
}
