/*
 * strb.c
 * contains: strb(),strblf(),strbrt()
 *	 
 *   Copyright (C)1987-1990 Greenleaf Software Inc. All Rights Reserved.
 *
 */

#include <stdio.h>
#include "gfuncts.h"

/*
 *  int
 * strb(ps,start,num)
 *
 * ARGUMENT
 *  (char *)	ps	-	string to be "operated on"
 *  (int)	start	-	position at which to start (0==leftmost)
 *  (int)	num	-	Number of characters to blank
 *
 * DESCRIPTION
 *  string blank function, characters are blanked beginning at position
 *  start.  Characters are replaced with BLANKS.
 *
 * RETURNS
 *  number of characters modified.
 */
int GF_CONV strb(ps,start,num)
char *ps;
int start,num;
{
	int GF_CONV strr();
	
	return(strr(ps,(char)BLANK,start,num));
}

/*
 *  int
 * strblf(ps,start)
 *
 * ARGUMENT
 *  (char *)	ps	-	string to be "operated on"
 *  (int)	num	-	Number of characters to blank
 *
 * DESCRIPTION
 *  string blank function, characters are blanked from the left. Characters 
 *  are replaced with BLANKS.
 *
 * RETURNS
 *  number of characters modified.
 */
int GF_CONV strblf(ps,num)
char *ps;
int num;
{
	int GF_CONV strrlf();
	
	return(strrlf(ps,(char)BLANK,num));
}

/*
 *  int
 * strbrt(ps,num)
 *
 * ARGUMENT
 *  (char *)	ps	-	string to be "operated on"
 *  (int)	num	-	Number of characters to blank
 *
 * DESCRIPTION
 *  string blank function, characters are blanked from the right.  
 *  Characters are replaced with BLANKS.
 *
 * RETURNS
 *  number of characters modified.
 */
int GF_CONV strbrt(ps,num)
char *ps;
int num;
{
	int GF_CONV strrrt();
	
	return(strrrt(ps,(char)BLANK,num));
}
