/*
 * strdetab.c
 * contains: strdetab()
 *
 */

#include <stdio.h>
#include "gfuncts.h"

/*
 *  char *
 * strdetab(destination,source,tabs,def,opt,maxlength)
 *
 * ARGUMENT
 *  (char *)	destination	-	points to destination string
 *  (char *)	source		-	points to source string
 *  (char *)	tabs		-	tab stops string
 *  (int)	def		-	default tab stop intervals
 *					(only used when tabs==NULL)
 *  (int)	opt		-	options
 *					1=convert tab to single space
 *					2=convert tab to two spaces
 *					3=space to next defined tab stop
 *  (int)	maxlength	-	maximum length of output string
 *
 * DESCRIPTION
 *  The source string is copied to the destination string except that
 *  tab characters are converted to a space or spaces.
 *
 * RETURNS
 *  pointer to destination string or NULL if source or destination are NULL
 *  or tabs is NULL and default is 0.
 *
 * AUTHOR
 *  ""   17-APR-1987  13:01:15.58
 *   Copyright (C)1987-1990 Greenleaf Software Inc. All Rights Reserved.
 */
char* GF_CONV strdetab(destination,source,tabs,def,opt,maxlength)
char *destination,*source,*tabs;
int def,opt,maxlength;
{
	char *orgdest;
	int column,count;
	
	if(!destination||!source||(opt==3&&!tabs&&!def)||opt<1||opt>3)
		return((char *)0);
	orgdest=destination;
	if(opt==1||opt==2)
		for(;*source&&maxlength;++source,--maxlength) {
			*destination++=(*source=='\t')?(char)' ':*source; 
			if(opt==2&&*source=='\t'&&--maxlength)
				*destination++=' ';
		}
	else
		if(tabs)
			for(;*source&&maxlength&&*tabs;++source,--maxlength)
				if(*source!='\t') {
					*destination++=*source;
					++tabs;
				} else
					for(;*tabs&&maxlength&&(*tabs!='t'&&
					    *tabs!='T'&&*tabs!='x'&&
					    *tabs!='X');++tabs,--maxlength)
					        *destination++=' ';
		else 
			for(column=0;*source&&maxlength;++source,--maxlength)
				if(*source!='\t') {
					*destination++=*source;
					++column;
				} else {
					count=column;
					while(++count%def)
						;
					count-=column;
					while(maxlength--&&count--){
						++column;
						*destination++=' ';
					}
				}
	*destination='\0';
	return(orgdest);
}
