/*
 * strmake.c
 * contains: 
 *
 */

#include <stdio.h>
#include <string.h>
#include "gfuncts.h"

/*
 *  char *
 * strmake( dst, s1,...)
 *
 * ARGUMENT
 *  char *dst;		Destination string area
 *  char *s1,..;	Source strings (NULL terminated)
 *
 * DESCRIPTION
 *  Concatenates all non-NULL strings s1-... into dst.
 *
 * SIDE EFFECTS
 *  No idea if overwrites destination area.
 *
 * RETURNS
 *  Pointer to destination string.  NULL if dst or s1 is NULL.
 *
 * AUTHOR
 *   DK  02-Mar-1989  15:47:04
 *   Copyright (C)1989-1990 Greenleaf Software Inc. All Rights Reserved.
 *
 * MODIFICATIONS
 *
 */
#ifndef _MSC
char* GF_CDECL strmake(dst,s1)
#else
char* GF_CDECL strmake(dst,s1,...)
#endif
char *dst,*s1;
{
	char **value;

	if(!dst||!s1)
		return(NULL);
	value=&s1;
	*dst='\0';
	while(*value) {
		strcat(dst,*value);
		++value;
	}
	return(dst);
}
