/*
 * strtrans.c
 * contains: strtranslate()
 *
 */

#include <stdio.h>
#include "gfuncts.h"

/*
 *  char *
 * strtranslate(destination,source,xlat,subs,opt,maxlength)
 *
 * ARGUMENT
 *  (char *)	destination	-	destination string
 *  (char *)	source		-	source string
 *  (char *)	xlat		-	characters to translate from
 *  (char *)	subs		-	characters to translate to
 *  (int)	option		-  1 =	No special action
 *  				   2 =  Omit translation on first character
 *					of word.
 *				   3 = 	Only translate first character of
 *					words.
 *
 * DESCRIPTION
 *  The source string is copied to the destination string, except that
 *  every character that matches a character in the xlat string is translated
 *  to the character in the subs string that is in the same position as the
 *  character in the xlat string.
 *
 * RETURNS
 *  Pointer to the destination string or NULL if any of the four pointer
 *  arguments are NULL or pointers to a NULL string.
 *
 * AUTHOR
 *  ""   14-APR-1987  17:32:00.28
 *   Copyright (C)1987-1990 Greenleaf Software Inc. All Rights Reserved.
 *
 * MODIFICATIONS
 *  Ruby Crawford	  12-OCT-1989
 *   Took out argument check for *destination to keep from getting
 *   invalid argument when computer was first turned on.
 */
char *GF_CONV strtranslate(destination,source,xlat,subs,option,maxlength)
char *destination,*source,*xlat,*subs;
int option,maxlength;
{
	char *s,*destsave,lastchar;
	int counter,firstcharw;

	if(!destination||!source||!maxlength||!*source||   
	   !*xlat||!*subs||!xlat||!subs)
		return((char *)0);
	for(lastchar=' ',destsave=destination;maxlength&&*source;
	    --maxlength,++source,++destination) {
		firstcharw=(_gisalpha(*source)&&lastchar==' ')?TRUE:FALSE;
		if(option==1||(option==2&&!firstcharw)||
		   (option==3&&firstcharw)) {
		        for(counter=0,s=xlat;*s&&*s!=*source;++s,++counter)
				;
			*destination=(*s)?*(subs+counter):*source;
		} else
			*destination=*source;
		lastchar=*source;
	}
	*destination='\0';
	return(destsave);
}
