/*
 * strwx.c
 * contains: strwx(),strwxlf(),strwxrt()
 *
 *   Copyright (C)1987-1990 Greenleaf Software Inc. All Rights Reserved.
 */

#include <stdio.h>
#include "gfuncts.h"

int GF_CONV strwc(),GF_CONV strwx(),GF_CONV strwxlf(),GF_CONV strwxrt();

/*
 *  int
 * strwx(pd,ps,frst,num)
 *
 * ARGUMENT
 *  (char *)	pd	-	pointer to destination string
 *  (char *)	ps	-	pointer to source string
 *  (int)	frst	-	first word to extract (from left 1=leftmost)
 *  (int)	num	-	number of words to extract
 *
 * DESCRIPTION
 *  The specified number of words or less are extracted from the source
 *  to the destination string, and the destination is terminated.
 *  Beginning with the word in the position indicated by pd and extracts
 *  num words.
 *
 * RETURNS
 *  number of characters extracted
 *
 * MODIFICATIONS
 *
 */
int GF_CONV strwx(pd,ps,frst,num)
char *ps,*pd;
int frst, num;
{
	int done,words,skip,totalwds,chs,inword,xferon,min1;

	totalwds=strwc(ps);
	min1=xmin(num,totalwds);
	words=xmax(0,min1);
	if(!words||frst>totalwds)
		return 0;
	skip=frst-1;
	chs=done=inword=0;
	if(skip)
		xferon=0;
	else 
		xferon = 1;
	while(*ps) {
		if(gisspace(*ps)) {
			if(inword) {
				inword = 0;
				++done;
				if(done>=(skip+words))
					xferon=0;
			} else 
				xferon=0;
		} else {
			inword=1;
			if(done==skip)
				xferon = 1;
		}
		if(xferon) {
			*pd++=*ps;
			++chs;
		}
		++ps;
	}
	*pd='\0';
	return chs;
}

/*
 *  int
 * strwxlf(pd,ps,num)
 *
 * ARGUMENT
 *  (char *)	pd	-	pointer to destination string
 *  (char *)	ps	-	pointer to source string
 *  (int)	num	-	number of words to extract
 *
 * DESCRIPTION
 *  The specified number of words or less are extracted from left
 *  side of the source to the destination string, and the destination 
 *  is terminated.
 *
 * RETURNS
 *  number of characters extracted
 *
 */
int GF_CONV strwxlf(pd,ps,num)
char *pd, *ps;
int num;
{
	int wdsinstr,wdstoget,min1;

	wdsinstr=strwc(ps);
	min1=xmin(num,wdsinstr);
	wdstoget=xmax(0,min1);
	return strwx(pd,ps,1,wdstoget);
}

/*
 *  int
 * strwxrt(pd,ps,num)
 *
 * ARGUMENT
 *  (char *)	pd	-	pointer to destination string
 *  (char *)	ps	-	pointer to source string
 *  (int)	num	-	number of words to extract
 *
 * DESCRIPTION
 *  The specified number of words or less are extracted from right
 *  side of the source to the destination string, and the destination 
 *  is terminated.
 *
 * RETURNS
 *  number of characters extracted
 */
int GF_CONV strwxrt(pd,ps,num)
char *pd,*ps;
int num;
{
	int firstword,wdsinstr,wdstoget,min1;

	wdsinstr=strwc(ps);
	min1=xmin(num,wdsinstr);
	wdstoget=xmax(0,min1);
	firstword=(wdsinstr-wdstoget)+1;
	return strwx(pd,ps,firstword,wdstoget);
}
