/*
 * strxlate.c
 * contains: strxlate()
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "gfuncts.h"

/*
 *  char *
 * strxlate(destination,source,xlat,subs,opt,maxlength)
 *
 * ARGUMENT
 *  (char *)	destination	-	destination string
 *  (char *)	source		-	source string
 *  (char **)	xlat		-	array of pointers to characters to 
 *					translate from.
 *  (char **)	subs		-	array of pointers to characters to 
 *					translate to.
 *
 *  (int)	option		-  1 =	No special action
 *  				   2 =  Omit translation on first character
 *					of word.
 *				   3 = 	Only translate first character of
 *					words.
 *
 * DESCRIPTION
 *  The source string is copied to the destination string, except that
 *  every character that matches a character in the xlat string is translated
 *  to the character in the subs string that is in the same position as the
 *  character in the xlat string.  The xlat strings are scanned sequentially
 *  until either a character is found that matches or a NULL pointer
 *
 * RETURNS
 *  Pointer to the destination string or NULL if any of the four pointer
 *  arguments are NULL or pointers to a NULL string or if unable to allocate
 *  internal buffer via malloc().
 *
 * AUTHOR
 *  ""   15-APR-1987  11:02:20.06
 *   Copyright (C)1987-1990 Greenleaf Software Inc. All Rights Reserved.
 */
char* GF_CONV strxlate(destination,source,xlat,subs,option,maxlength)
char *destination,*source,**xlat,**subs;
int option,maxlength;
{
	char *newsource;
	
	if(!destination||!source||!maxlength||!*destination||!*source||
	   !*xlat||!*subs||!xlat||!subs||
	   (newsource=malloc(strlen(source)+1))==NULL)
		return((char *)0);
	for(strcpy(newsource,source);*xlat&&*subs;++xlat,++subs)
		if(strtranslate(destination,newsource,*xlat,*subs,option,
								maxlength))
		        strcpy(newsource,destination);
	free(newsource);
	return(destination);
}
